/* Disassembles ".HEX" files
   Copyright (C) 2001, 2002, 2003, 2004, 2005
   Craig Franklin

    Copyright (C) 2014-2016 Molnar Karoly
*/

#pragma once

#include "labelset.h"

#define GPDASM_VERSION_STRING       ("gpdasm-" VERSION " #" REVISION " (" __DATE__ ")")

extern struct gpdasm_state {
  pic_processor_t  processor;   /* selected processor */
  proc_class_t     class;       /* processor class */
  int              format;      /* format of the output */
  int              pass;        /* 1 or 2 */
  MemBlock_t      *i_memory;    /* Instruction memory linked list. */

  char *srcfilename,            /* Source (.asm) file name */
        basefilename[BUFSIZ],   /* Basename for generating hex,list,symbol filenames. */
        hexfilename[BUFSIZ];    /* Hex (.hex) file name */

  hex_data_t                *hex_info;    /* information on input hex file */
  const gp_register_table_t *proc_regs;

  struct {                      /* Totals for errors, warnings, messages. */
    int errors;
    int warnings;
    int messages;
  } num;

  gp_boolean show_names;
  gp_boolean show_fsrn;
  gp_boolean show_config;
  gp_boolean need_sfr_equ;
  gp_boolean use_tab;

  lset_section_root_t lset_root;
} state;
