/* gplib - GNU PIC librarian
   Copyright (C) 2001, 2002, 2003, 2004, 2005
   Craig Franklin

    Copyright (C) 2016 Molnar Karoly
*/

#pragma once

enum lib_modes {
  AR_CREATE,
  AR_DELETE,
  AR_EXTRACT,
  AR_LIST,
  AR_REPLACE,
  AR_SYMBOLS,
  AR_NULL
};

#define GPLIB_VERSION_STRING        ("gplib-" VERSION " #" REVISION " (" __DATE__ ")")

#define MAX_OBJ_NAMES 256

extern struct gplib_state {
  enum lib_modes  mode;                        /* operating mode */
  int             numobjects;                  /* number of objects in the list */
  char           *filename;                    /* library file name */
  char           *objectname[MAX_OBJ_NAMES];   /* the list of object filenames */
  gp_archive_t   *archive;                     /* internal archive format */
} state;
